<?php

// Subject Source Directory functions

function source_connect(&$ldap) {
	$binddn = $ldap['user'] . "," . $ldap['basedn'];
	$ldap['bind'] = FALSE;
	$ldap['link'] = ldap_connect($ldap['host'], $ldap['port']);
	if ($ldap['link'] !== FALSE) {
		ldap_set_option($ldap['link'], LDAP_OPT_PROTOCOL_VERSION, 3);
		$ldap['bind'] = ldap_bind($ldap['link'], $binddn, $ldap['password']);
	}
	return $ldap['bind'];
}

function source_profile($ldap, $uuid) {
	// TODO: configurable settings for both "internal" and "external" (user viewable) attributes
	$attrs = array_merge(
		array_values($ldap['attributes']),
		array('espeeUid', 'espeeGuest')
	);
	$ds = ldap_search($ldap['link'], $ldap['basedn'], "(espeeUid=$uuid)", $attrs);
	if ($ds !== FALSE) {
		$entry = ldap_first_entry($ldap['link'], $ds);
		if ($entry !== FALSE) {
			return ldap_get_attributes($ldap['link'], $entry);
		}
	}
	return FALSE;
}

?>
